package fxmaju;



import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.TextArea;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import javafx.fxml.FXML;
import javafx.scene.text.Font;
import majuKomponentit.*;

import java.awt.*;
import java.io.IOException;
import java.io.PrintStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.List;


/**
 * @author maurihase
 * @version 31.1.2025
 */
public class majuController {
    @FXML private ScrollPane panelPeli;
    @FXML private ListChooser<Peli> chooserPelit;


    @FXML
    void handleEtsi() {
        Dialogs.showMessageDialog("En osaa hakea ;(");
    }

    @FXML
    void handleLisaus() {
        avaa();
    }

    @FXML
    void handleMuokkaus() {
        Dialogs.showMessageDialog("En osaa muokata ;(");
        avaa();
    }

    @FXML
    void handlePoisto() {
        Dialogs.showMessageDialog("En osaa poistaa ;(");
    }

    @FXML
    void lahetaApuun() {
        avunAnto();
    }

    @FXML
    void handleNaytaTiedot() {
        Dialogs.showMessageDialog("En osaa näyttää tietoja ;(");
        naytaTiedot();
    }

    //——————————————————————————————————————————————————————————————————————————————————————————————————————————\\
    //Atribuutteja
    private Maju maju;

    private TextArea areaPeli = new TextArea();
    private Peli pelinTiedot;
    private String tiedot;
    private Maju pelit = new Maju();


    /**
     * näyttää tietosivun
     * @return tietosivu
     */
    private boolean naytaTiedot() {
        String majuTiedot = MajutietosivuGUIController.naytaTieto(null, tiedot, maju);
        if (majuTiedot == null) return false;
        return true;
    }


    /**
     * Avaa uuden ikkunan
     */
    public void avaa() {
        Peli uusiPeli = majuLisaaPeliController.kysyPeli(null, pelinTiedot, maju);
        if (uusiPeli == null) return;
        hae(0);
    }


    /**
     * Asettaa MAJUn
     * @param maju pääluokka
     */
    public void setMaju(Maju maju) {
        this.maju = maju;
        alusta();
        luetiedosto();
        naytaPeli();
    }


    /**
     * Alustaa pelinäkymän ja pelien tietojen näkymän
     */
    protected void alusta() {
        panelPeli.setContent(areaPeli);
        areaPeli.setFont(new Font("Comic Sans", 12));
        panelPeli.setFitToHeight(true);
        chooserPelit.clear();
        chooserPelit.addSelectionListener(e -> naytaPeli());
    }


    /**
     * Näyttää pelin tiedot
     */
    private void naytaPeli() {
        Peli peliKohdalla = chooserPelit.getSelectedObject();
        List<Genre> genrenNimet = maju.annaGenret(peliKohdalla);
        if(peliKohdalla == null) return;
        areaPeli.setText("");
        try (PrintStream os = TextAreaOutputStream.getTextPrintStream(areaPeli)) {
            peliKohdalla.tulosta(os);
            genrenNimet.forEach(peli -> peli.tulosta(os));
        }
    }


    /**
     * Lisää uuden pelin
     */
    protected void uusiPeli() {
        Peli uusi = new Peli("Testi peli", "Majuri Studios", "Majuri Studios", 2025, "Windows, MacOS", "Ei", "NR", "NR", "Ei");
        uusi.rekistoroi();
        try{
            maju.lisaa(uusi);
        }catch (SailoException e){
            Dialogs.showMessageDialog("Ongelmia uuden pelin luomisessa! " + e.getMessage());
            return;
        }
        hae(uusi.getTunnusnro());
    }


    /**
     * Hakee pelejä
     * @param tunnusnro pelin tunnusnumero
     */
    protected void hae(int tunnusnro) {
        chooserPelit.clear();
        int index = 0;
        for (int i = 0; i < maju.getPeleja(); i++) {
            Peli peli = pelit.annaPeli(i);
            if (peli.getTunnusnro() == tunnusnro) index = i;
            chooserPelit.add(peli.getNimi(), peli);
        }
        chooserPelit.setSelectedIndex(index);
    }


    /**
     * Lukee tiedostoja
     * @return jos tulee virhe, niin sen
     */
    protected String luetiedosto() {
        try {
            maju.lueTiedostosta();
            hae(0);
            return null;
        }catch (SailoException e){
            hae(0);
            String virhe = e.getMessage();
            if (virhe != null) Dialogs.showMessageDialog(virhe);
            return virhe;
        }
    }


    public void avunAnto() {
        Desktop desktop = Desktop.getDesktop();
        try {
            URI uri = new URI("https://tim.jyu.fi/view/kurssit/tie/ohj2/v/2025/kevat/ht/hasemajo#menutoiminnot-yksityiskohtaisemmin");
            desktop.browse(uri);
        } catch (URISyntaxException ue) {
            return;
        } catch (IOException ioe){
            return;
        }
    }
}