package majuKomponentit;

import fi.jyu.mit.ohj2.Mjonot;

import java.io.PrintStream;

/**
 * @author jpaaj
 * @version 8.4.2025
 *
 */
public class Peli {
    //Atribuutteja pelien tiedoille
    private int id = 0;
    private String peliNimi = " ";
    private String peliJulkaisija = " ";
    private String peliValmistaja = " ";
    private int peliVuosi;
    private String peliAlusta = " ";
    private String peliLisaosat = " ";
    private String arvosanaIGN = "0/10";
    private String arvosanaMAJU = "0/10";
    private String suositus = " ";

    private static int seuraavaID = 1;


    /**
     * Alustus pelin tiedoille
     * @param nimi pelille
     * @param julkaisija pelille
     * @param valmistaja pelille
     * @param vuosi jona peli julkaistiin
     * @param alusta jolla peliä voidaan pelata
     * @param lisaOsat jos niitä on, jotta voidaan saada lisää rahaa sinulta
     * @param arvosanaIGN josta nähdään pelin laatu
     * @param arvosanaMAJU jotta saadaan kilpailevaa mielipidettä
     * @param suositus suosittelisitko peliä muille?
     */
    public Peli(String nimi, String julkaisija, String valmistaja, int vuosi, String alusta, String lisaOsat, String arvosanaIGN, String arvosanaMAJU, String suositus) {
        this.peliNimi = nimi;
        this.peliJulkaisija = julkaisija;
        this.peliValmistaja = valmistaja;
        this.peliVuosi = vuosi;
        this.peliAlusta = alusta;
        this.peliLisaosat = lisaOsat;
        this.arvosanaIGN = arvosanaIGN;
        this.arvosanaMAJU = arvosanaMAJU;
        this.suositus = suositus;
    }


    /**
     * testi peli
     */
    public Peli (){
        new Peli("Vankilapako", "Majuri Studios", "Majuri Studios", 2024, "Windows", "Ei", "0/10", "10/10", "Kyllä");
    }

    /**
     * Hallitsee pelin tiedot
     * @param args e
     */
    public static void main(String[] args){
        //Vankilapaolle pohja
        Peli vankilapako = new Peli("Vankilapako", "Majuri Studios", "Majuri Studios", 2024, "Windows", "Ei", "0/10", "10/10", "Kyllä");
        vankilapako.rekistoroi();
        vankilapako.tulosta(System.out);

        //Half Sword:n pohja
        Peli halfSword = new Peli("Half Sword", "Game Seer Publishing", "Half Sword Games", 2025, "Windows 10/11", "Ei", "0/10", "0/10", "Ei vielä");
        halfSword.rekistoroi();
        halfSword.tulosta(System.out);
    }


    /**
     * Tulostaa pelin tiedot ulos
     * @param out systeemin linja
     */
    public void tulosta(PrintStream out) {
        out.println(String.format("%05d", this.id) + " " + this.peliNimi);
        out.println("Pelin valmistaja: " + this.peliValmistaja);
        out.println("Pelin julkaisija: " + this.peliJulkaisija);
        out.println("Pelin julkaisu vuosi: " + this.peliVuosi);
        out.println("Pelin alusta: " + this.peliAlusta);
        out.println("Pelin lisaosat: " + this.peliLisaosat);
        out.println("Pelin IGN-arvosana: " + this.arvosanaIGN);
        out.println("Pelin MAJU-arvosana: " + this.arvosanaMAJU);
        out.println("Suositellaanko: " + this.suositus + "\n");
    }


    /**
     * Antaa pelille ID numeron
     * @return palauttaa ID:n
     */
    public int rekistoroi() {
        this.id = seuraavaID;
        seuraavaID++;
        return id;
    }


    /**
     * Hakee tunnusnumeron
     * @return tunnusnumeron/id:n
     */
    public int getTunnusnro() {
        return this.id;
    }


    /**
     * Hakee nimen
     * @return nimen
     */
    public String getNimi(){
        return this.peliNimi;
    }


    /**
     * @param id Tunnusnumero
     */
    public void setTunnusNumero(int id) {
        this.id = id;
        if(id >= seuraavaID) seuraavaID = id + 1;
    }


    /**
     * Tiedoston lukemista varten sääntöjä
     * @param rivi , joka saatiin tiedostosta, jota muutetaan
     */
    public void parse(String rivi) {
        StringBuilder sb = new StringBuilder(rivi);
        setTunnusNumero(Mjonot.erota(sb, '|', getTunnusnro()));
        peliNimi = Mjonot.erota(sb, '|', getNimi());
        peliJulkaisija = Mjonot.erota(sb, '|', peliJulkaisija);
        peliValmistaja = Mjonot.erota(sb, '|', peliValmistaja);
        peliVuosi = Mjonot.erota(sb, '|', peliVuosi);
        peliAlusta = Mjonot.erota(sb, '|', peliAlusta);
        peliLisaosat = Mjonot.erota(sb, '|', peliLisaosat);
        arvosanaIGN = Mjonot.erota(sb, '|', arvosanaIGN);
        arvosanaMAJU = Mjonot.erota(sb, '|', arvosanaMAJU);
        suositus = Mjonot.erota(sb, '|', suositus);
    }



    

    /**
     * Muuttaa tallennettavan pelin tiedot oikeaan muotoon
     * @return kirjoitettava tallennus muoto, oikea sellainen
     */
    @Override
    public String toString(){
        return getTunnusnro() + "|" + peliNimi + "|" + peliJulkaisija + "|" + peliValmistaja + "|" + peliVuosi + "|" + peliAlusta + "|" + peliLisaosat + "|" + arvosanaIGN + "|" + arvosanaMAJU + "|" + suositus;

    }
}
